#ifndef R10LP_H
#define R10LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R10LP_K 10

typedef struct r10lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Ten different reader phases
    rklp_group_t groups[R10LP_K];

    // Potentially cache lock state to handle race condition on unlock
    rklp_cached_state_t cached_state[R10LP_K];

} __attribute ((aligned (64) )) r10lp_t;

void r10lp_init(r10lp_t *lock);

uint64_t *r10lp_lock(r10lp_t *lock, unsigned int groupnum);
uint64_t *r10lp_unlock(r10lp_t *lock, unsigned int groupnum);

#endif // R10LP_H
