#ifndef R4LP_H
#define R4LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R4LP_K 4

typedef struct r4lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Four different reader phases
    rklp_group_t groups[R4LP_K];

    // Potentially cache lock state to handle race condition on unlock
    rklp_cached_state_t cached_state[R4LP_K];

} __attribute ((aligned (64) )) r4lp_t;

void r4lp_init(r4lp_t *lock);

uint64_t *r4lp_lock(r4lp_t *lock, unsigned int groupnum);
uint64_t *r4lp_unlock(r4lp_t *lock, unsigned int groupnum);

#endif // R4LP_H
