#ifndef R5LP_H
#define R5LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R5LP_K 5

typedef struct r5lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Five different reader phases
    rklp_group_t groups[R5LP_K];

    // Potentially cache lock state to handle race condition on unlock
    rklp_cached_state_t cached_state[R5LP_K];

} __attribute ((aligned (64) )) r5lp_t;

void r5lp_init(r5lp_t *lock);

uint64_t *r5lp_lock(r5lp_t *lock, unsigned int groupnum);
uint64_t *r5lp_unlock(r5lp_t *lock, unsigned int groupnum);

#endif // R5LP_H
