#ifndef R6LP_H
#define R6LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R6LP_K 6

typedef struct r6lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Six different reader phases
    rklp_group_t groups[R6LP_K];

    // Potentially cache lock state to handle race condition on unlock
    rklp_cached_state_t cached_state[R6LP_K];

} __attribute ((aligned (64) )) r6lp_t;

void r6lp_init(r6lp_t *lock);

uint64_t *r6lp_lock(r6lp_t *lock, unsigned int groupnum);
uint64_t *r6lp_unlock(r6lp_t *lock, unsigned int groupnum);

#endif // R6LP_H
