#ifndef R7LP_H
#define R7LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R7LP_K 7

typedef struct r7lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Seven different reader phases
    rklp_group_t groups[R7LP_K];

    // Potentially cache lock state to handle race condition on unlock
    rklp_cached_state_t cached_state[R7LP_K];

} __attribute ((aligned (64) )) r7lp_t;

void r7lp_init(r7lp_t *lock);

uint64_t *r7lp_lock(r7lp_t *lock, unsigned int groupnum);
uint64_t *r7lp_unlock(r7lp_t *lock, unsigned int groupnum);

#endif // R7LP_H
